var xrayReactClientMin = (function () {
  'use strict';

  const xrayReactElemCN = 'xray-react-element';
  const xrayReactWrapperCN = 'xray-react-elements-wrapper';
  const xrayReactCompPathAttr = 'data-xray-react-components-path';
  const zIndex = 10000;

  var constants = {
    xrayReactElemCN,
    xrayReactWrapperCN,
    xrayReactCompPathAttr,
    zIndex
  };

  const { xrayReactElemCN: xrayReactElemCN$1, xrayReactCompPathAttr: xrayReactCompPathAttr$1 } = constants;
  const IO_CONNECT_URL = 'http://127.0.0.1:8124';


  const ClientIO = function() {
    this.client = null;
  };

  ClientIO.prototype.addScript = function() {
    let script = document.createElement('script');
    script.type = 'text/javascript';
    script.async = true;
    script.src = 'https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.1.1/socket.io.js';

    return new Promise((resolve) => {
      script.addEventListener('load', function(e) {
        resolve(true);
        script.remove();
      });

      script.addEventListener('error', function(e) {
        resolve(false);
        script.remove();
      });

      document.body.appendChild(script);
    });
  };

  ClientIO.prototype.init = function() {
    return new Promise((resolve) => {
      if (typeof window.io === 'undefined') {
        this.addScript().then((isSuccess) => {
          if (isSuccess) {
            this.client = window.io.connect(IO_CONNECT_URL);
            resolve(true);
          } else {
            resolve(false);
          }
        });
      } else {
        this.client = window.io.connect(IO_CONNECT_URL);
        resolve(true);
      }
    });
  };

  const initIOAndListeners = function() {
    const clientIO = new ClientIO();
    clientIO.init().then((isSuccess) => {
      if (isSuccess) {
        document.body.addEventListener('click', function(event) {
          let target = event.target;
          if (target.className.includes(xrayReactElemCN$1)) {
            clientIO.client.emit('xray-react-component', target.getAttribute(xrayReactCompPathAttr$1));
          }
        });
      }
    });
  };

  window.onload = function() {
    initIOAndListeners();
  };

  var xrayReactClient = {

  };

  return xrayReactClient;

}());
